// \AvP[V
//    u@@@v@
// ʓIȊ֐Q (myfunc.cpp)

#include "myfunc.h"

// EBhEo^
BOOL RegistWndClass(UINT style,WNDPROC wndProc,HINSTANCE hInst,
					HICON hIcon,HCURSOR hCursor,HBRUSH hbrBack,
					LPCTSTR lpszMenu,LPCTSTR lpszClassName){

   WNDCLASS wndClass;

   wndClass.style            =style;
   wndClass.lpfnWndProc      =wndProc;
   wndClass.cbClsExtra       =0;
   wndClass.cbWndExtra       =0;
   wndClass.hInstance        =hInst;
   wndClass.hIcon			=hIcon;
   wndClass.hCursor			 =hCursor; 
   wndClass.hbrBackground    =hbrBack;
   wndClass.lpszMenuName	  =lpszMenu;
   wndClass.lpszClassName	  =lpszClassName;
   
   if (!RegisterClass(&wndClass)) return FALSE;
   
   return TRUE;
}
	

// AvP[VstH_̎擾
VOID GetExeDir(char* lpszPath){
	
	char str[CHR_BUF],driveName[CHR_BUF],pathName[CHR_BUF];
	
	GetModuleFileName(NULL,str,CHR_BUF);
	_splitpath(str,driveName,pathName,NULL, NULL);	
	wsprintf(lpszPath,"%s%s",driveName,pathName);
}


// MDI ̍쐬
VOID CreateMyMdiWindow(HWND* lphMdiWnd,HWND hClientWnd,
					   HINSTANCE hInst,char* szClass,char* szTitle,
					   int x,int y,DWORD width,DWORD height,
					   int nStat){
	
	MDICREATESTRUCT mdicStruct;

	mdicStruct.szClass = szClass;
	mdicStruct.szTitle = szTitle;
	mdicStruct.hOwner = hInst;
	if(nStat == MDIWIN_CLOSE){
		mdicStruct.x = CW_USEDEFAULT;
		mdicStruct.y = CW_USEDEFAULT;
		mdicStruct.cx = DEFAULT_FFTPOINT+100;
		mdicStruct.cy = DEFAULT_FFTPOINT/2+100;
	}
	else{
		mdicStruct.x = x;
		mdicStruct.y = y;
		mdicStruct.cx = width;
		mdicStruct.cy = height;
	}

	mdicStruct.style 
		= WS_CHILD|WS_VISIBLE|
		WS_CLIPSIBLINGS|WS_SYSMENU|WS_CAPTION|WS_THICKFRAME|
		WS_MINIMIZEBOX|WS_MAXIMIZEBOX|WS_VSCROLL|WS_HSCROLL;

	if(nStat == MDIWIN_MAX || nStat == MDIWIN_INIT) mdicStruct.style |= WS_MAXIMIZE;

	mdicStruct.lParam = 0;
	
	// EBhE쐬
	*lphMdiWnd=(HWND)SendMessage(hClientWnd,WM_MDICREATE,0,(LPARAM)&mdicStruct);
	
}	

// V[gt@COt@C֕ϊ֐
BOOL ShortToLongName(char* lpFileName){
	
	char fPath[MAX_PATH],fDrive[MAX_PATH],fName[MAX_PATH],fExt[MAX_PATH]; 
	WIN32_FIND_DATA findData;
	HANDLE hFind;
	
	hFind = FindFirstFile(lpFileName,&findData);
	
	if(hFind==INVALID_HANDLE_VALUE) return FALSE;
	
	FindClose(hFind); 
	
	_splitpath(lpFileName,fDrive,fPath,fName, fExt);	
	wsprintf(lpFileName,"%s%s%s",fDrive,fPath,findData.cFileName);  

	return TRUE;
}

//-------------------------------------
//  MDI EBhẺz`TCYvZ
VOID CalcChildWinSize(WAVEFORMATEX waveFmt,HANDLE hdWaveFile,
					  WORD viewStat,
					  LPDWORD lpChildWidth,LPDWORD lpChildHeight,
					  LPDWORD widthRate,LPDWORD heightRate){
	
	DWORD waveChn; // `l
	
    // `l̐ݒ
	waveChn = hdWaveFile == NULL ? 2 : waveFmt.nChannels;
	
	// `̈(zI)傫vZ
	if(viewStat==WINID_SPEC){  // XyNg
		*lpChildWidth = DEFAULT_FFTPOINT*widthRate[WINID_SPEC]+70;
		*lpChildHeight = DEFAULT_FFTPOINT/2/(3-waveChn)*heightRate[WINID_SPEC] +70;
	}
	else if(viewStat==WINID_SEIMON){ // 
		*lpChildWidth = DEFAULT_FFTPOINT/2*waveChn*widthRate[WINID_SEIMON]+70;
		*lpChildHeight = DEFAULT_FFTPOINT/2*heightRate[WINID_SEIMON]+70;
	}
	else{ // g`
		*lpChildWidth = DEFAULT_FFTPOINT+20;
		*lpChildHeight = DEFAULT_FFTPOINT/2/(3-waveChn)+40;
	}
}


//-------------------------------------
// INI t@Cǂݏ
VOID OpenIniFile(WORD mode,char* seimonPath,LPDWORD lpFftPoint,LPWORD lpWinFunc
				 ,LPDWORD lpWidthRate,LPDWORD lpHeightRate,LPBOOL lpbLogY,
				 LPBOOL lpbLogZ,LPLONG lpnZbase,
				 int* lpnAmp,
				 LPWININFO lpWinInfo,LPBOOL lpbMono)
{	
	int i;
	char str[MAX_PATH],str2[CHR_BUF],str3[CHR_BUF],szLockonPath[MAX_PATH];
	
	wsprintf(str,"%s%s",seimonPath,"seimon.ini");
	wsprintf(szLockonPath,"%s%s",seimonPath,"lockon.ini");
	
	if(mode == 0){ // ǂݍ
		
		// ini t@C쐬
		HANDLE hdFile;
		
		hdFile = CreateFile(str,GENERIC_READ
			,0, 0, OPEN_EXISTING,FILE_ATTRIBUTE_READONLY, NULL); 
		
		if(hdFile == INVALID_HANDLE_VALUE){ 
			*lpFftPoint = 512;
			*lpWinFunc = 1;
			lpWidthRate[0] = 1;
			lpWidthRate[1] = 1;
			lpHeightRate[0] = 1;
			lpHeightRate[1] = 1;
			*lpbLogY = FALSE;
			*lpbLogZ = FALSE;
			*lpnZbase = -10;
			*lpnAmp = 100;
			lpWinInfo->stat[WINID_SEIMON] = MDIWIN_INIT;
			lpWinInfo->stat[WINID_SPEC] = MDIWIN_CLOSE;
			lpWinInfo->stat[WINID_HAKEI] = MDIWIN_CLOSE;
			lpWinInfo->stat[MDIWND_NUM] = MDIWIN_INIT;
			*lpbMono = FALSE;
		}
		else
		{
			CloseHandle(hdFile);
			
			// ݒǂݍ
			GetPrivateProfileString("GLOBAL",	"FFTPOINT","512", str2,CHR_BUF,str); 
			*lpFftPoint = atoi(str2);
			if(*lpFftPoint != 256 && *lpFftPoint != 512 && *lpFftPoint != 1024 && *lpFftPoint != 2048) *lpFftPoint = 512;
			
			GetPrivateProfileString("GLOBAL",	"WINFUNC","1", str2,CHR_BUF,str); 
			*lpWinFunc = atoi(str2);
			if(*lpWinFunc != 0 && *lpWinFunc != 1 && *lpWinFunc != 2) *lpWinFunc = 1;
			
			GetPrivateProfileString("GLOBAL",	"WIDTHRATE0","1", str2,CHR_BUF,str); 
			lpWidthRate[0] = atoi(str2);
			if(lpWidthRate[0] != 1 && lpWidthRate[0] !=2 && lpWidthRate[0] !=4 ) lpWidthRate[0] = 1;
			
			GetPrivateProfileString("GLOBAL",	"WIDTHRATE1","1", str2,CHR_BUF,str); 
			lpWidthRate[1] = atoi(str2);
			if(lpWidthRate[1] != 1 && lpWidthRate[1] !=2 && lpWidthRate[1] !=4 ) lpWidthRate[1] = 1;
			
			GetPrivateProfileString("GLOBAL",	"HEIGHTRATE0","1", str2,CHR_BUF,str); 
			lpHeightRate[0] = atoi(str2);
			if(lpHeightRate[0] != 1 && lpHeightRate[0] !=2 && lpHeightRate[0] !=4 ) lpHeightRate[0] = 1;
			
			GetPrivateProfileString("GLOBAL",	"HEIGHTRATE1","1", str2,CHR_BUF,str); 
			lpHeightRate[1] = atoi(str2);
			if(lpHeightRate[1] != 1 && lpHeightRate[1] !=2 && lpHeightRate[1] !=4 ) lpHeightRate[1] = 1;
			
			GetPrivateProfileString("GLOBAL",	"LOGY","0", str2,CHR_BUF,str); 
			*lpbLogY = atoi(str2);

			GetPrivateProfileString("GLOBAL",	"LOGZ","0", str2,CHR_BUF,str); 
			*lpbLogZ = atoi(str2);
			
			GetPrivateProfileString("GLOBAL",	"ZBASE","-10", str2,CHR_BUF,str); 
			*lpnZbase = atoi(str2);

			GetPrivateProfileString("GLOBAL",	"AMP","100", str2,CHR_BUF,str); 
			*lpnAmp = atoi(str2);
	
			GetPrivateProfileString("GLOBAL",	"MONO","0", str2,CHR_BUF,str); 
			*lpbMono = atoi(str2);
		
			// MDI EBhEʒu
			for(i=0;i<=MDIWND_NUM;i++){
				int x,y,w,h;
				wsprintf(str3,"MDI%d",i);
				GetPrivateProfileString(str3,"STAT","2", str2,CHR_BUF,str); 
				lpWinInfo->stat[i] = atoi(str2);
				GetPrivateProfileString(str3,"X","0", str2,CHR_BUF,str); 
				x = atoi(str2);
				GetPrivateProfileString(str3,"Y","0", str2,CHR_BUF,str); 
				y = atoi(str2);
				GetPrivateProfileString(str3,"W","100", str2,CHR_BUF,str); 
				w = atoi(str2);
				GetPrivateProfileString(str3,"H","100", str2,CHR_BUF,str); 
				h = atoi(str2);

				lpWinInfo->x[i] = x;
				lpWinInfo->y[i] = y;
				lpWinInfo->w[i] = w;
				lpWinInfo->h[i] = h;
			}
			
		}

	}
	else { // 
		
		itoa(*lpFftPoint,str2,10);
		WritePrivateProfileString("GLOBAL",	"FFTPOINT",str2, str );
		itoa(*lpWinFunc,str2,10);
		WritePrivateProfileString("GLOBAL",	"WINFUNC",str2, str );
		itoa(lpWidthRate[0],str2,10);
		WritePrivateProfileString("GLOBAL",	"WIDTHRATE0",str2, str );
		itoa(lpWidthRate[1],str2,10);
		WritePrivateProfileString("GLOBAL",	"WIDTHRATE1",str2, str );
		itoa(lpHeightRate[0],str2,10);
		WritePrivateProfileString("GLOBAL",	"HEIGHTRATE0",str2, str );
		itoa(lpHeightRate[1],str2,10);
		WritePrivateProfileString("GLOBAL",	"HEIGHTRATE1",str2, str );
		itoa(*lpbLogY,str2,10);
		WritePrivateProfileString("GLOBAL",	"LOGY",str2, str );
		itoa(*lpbLogZ,str2,10);
		WritePrivateProfileString("GLOBAL",	"LOGZ",str2, str );
		itoa(*lpnZbase,str2,10);
		WritePrivateProfileString("GLOBAL",	"ZBASE",str2, str );
		itoa(*lpnAmp,str2,10);
		WritePrivateProfileString("GLOBAL",	"AMP",str2, str );
		itoa(*lpbMono,str2,10);
		WritePrivateProfileString("GLOBAL",	"MONO",str2, str );
		
		// MDI EBhEʒu
		for(i=0;i<=MDIWND_NUM;i++){
			wsprintf(str3,"MDI%d",i);
			itoa(lpWinInfo->stat[i],str2,10);
			WritePrivateProfileString(str3,"STAT",str2, str );
			itoa(lpWinInfo->x[i],str2,10);
			WritePrivateProfileString(str3,"X",str2, str );
			itoa(lpWinInfo->y[i],str2,10);
			WritePrivateProfileString(str3,"Y",str2, str );
			itoa(lpWinInfo->w[i],str2,10);
			WritePrivateProfileString(str3,"W",str2, str );
			itoa(lpWinInfo->h[i],str2,10);
			WritePrivateProfileString(str3,"H",str2, str );
		}
	}
}



//-------------------------------------
// eo[t
VOID CreateMyBar(HWND hWnd,HINSTANCE hInst,HWND* lphTimeBar,
				 HWND* lphAmpBar,HWND* lphStatBar,
				 HWND* lphToolBar){
	
	int i,i2; // Gp
	
	// c[o[ݒ
	TBBUTTON tbButton[]={
		{0, ID_TBTOHEAD, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
		{1, ID_TBREWIND, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0}, 
		{2, ID_TBPLAY, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
		{3, ID_TBPAUSE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0}, 
		{4, ID_TBFORWARD, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0}, 
		{5, ID_TBTOTAIL, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
		{6, ID_TBSEIMON, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0}, 
		{7, ID_TBSPEC, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
		{8, ID_TBHAKEI, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
		{9, ID_TBYAXIS, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0}, 
		{10, ID_TBFRAMESIZE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
		{11, ID_TBRESET, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
		{12, ID_TBHELP, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
		{STD_FILEOPEN, ID_TBOPEN, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
		{STD_FILESAVE, ID_TBSAVE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},	  
		{STD_COPY, ID_TBCOPY, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
		{STD_PROPERTIES, ID_TBSETTING, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
		{STD_DELETE, ID_TBCLOSE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
	};
	
	// 󔒃{^
	TBBUTTON tbSpButton = {0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0}; 
	// ̃{^
	TBADDBITMAP tBitmap; 
	
	//ԃo[t
	*lphTimeBar = CreateWindowEx(
		0,
		TRACKBAR_CLASS
		,NULL,
		WS_CHILD|WS_VISIBLE|TBS_HORZ|TBS_AUTOTICKS|TBS_BOTTOM
		,0,0,0,0,
		hWnd,
		(HMENU)ID_SCRBAR
		,hInst
		,NULL);
	
	// ߃o[\t
	*lphAmpBar=CreateWindowEx(
		0,
		TRACKBAR_CLASS,
		NULL,
		WS_CHILD|WS_VISIBLE|TBS_VERT|TBS_AUTOTICKS|TBS_LEFT,
		0,0,0,0,
		hWnd,
		(HMENU)ID_TRACKBAR,
		hInst,
		NULL);

	
	// Xe[^Xo[\t
	*lphStatBar = CreateStatusWindow(
		WS_CHILD | WS_VISIBLE | CCS_BOTTOM | SBARS_SIZEGRIP,
		NULL,
		hWnd,
		ID_STATBAR);
	
   	// Xe[^Xo[ݒ
	int sbPart[4];
	SendMessage(*lphStatBar, SB_SETPARTS, (WPARAM)4, (LPARAM)(LPINT)sbPart);
	
	// Xe[^Xo[Zbg
	SendMessage(GetDlgItem(hWnd,ID_STATBAR),SB_SETTEXT,3|0,(LPARAM)" x  1.0000"); 
	
	// c[o[\t
	*lphToolBar = CreateToolbarEx(
		hWnd, 
		WS_CHILD | WS_VISIBLE |TBSTYLE_TOOLTIPS, 
		ID_TOOLBAR, 
		13, //C[W
		hInst,
		IDB_TOOLBAR, // rbg}bvt@C
		tbButton,
		13, // {^
		0,0,16,15,sizeof(TBBUTTON));
	
	// ̃c[o[{^̃[hƒt
	tBitmap.hInst = HINST_COMMCTRL;
	tBitmap.nID = IDB_STD_SMALL_COLOR;
	i = SendMessage(*lphToolBar,TB_ADDBITMAP,5,(LPARAM)&tBitmap);
	for(i2=13;i2<=17;i2++) tbButton[i2].iBitmap += i;
	SendMessage(*lphToolBar,TB_INSERTBUTTON,0,(LPARAM)&tbButton[13]);
 	SendMessage(*lphToolBar,TB_INSERTBUTTON,1,(LPARAM)&tbButton[17]);
	SendMessage(*lphToolBar,TB_INSERTBUTTON,2,(LPARAM)&tbButton[14]);
	SendMessage(*lphToolBar,TB_INSERTBUTTON,3,(LPARAM)&tbButton[15]);
 	SendMessage(*lphToolBar,TB_INSERTBUTTON,14,(LPARAM)&tbButton[16]);
	
	// c[o[ɋ󔒑}		  	
	SendMessage(*lphToolBar,TB_INSERTBUTTON,4,(LPARAM)&tbSpButton);	
	SendMessage(*lphToolBar,TB_INSERTBUTTON,11,(LPARAM)&tbSpButton);
	SendMessage(*lphToolBar,TB_INSERTBUTTON,15,(LPARAM)&tbSpButton);
	SendMessage(*lphToolBar,TB_INSERTBUTTON,20,(LPARAM)&tbSpButton);
	
}


//-------------------------------------
// c[o[`bv\֐
VOID ShowToolbarChip(LPARAM lp,HINSTANCE hInst){
	
	
	LPTOOLTIPTEXT lpTip; 
	
	lpTip = (LPTOOLTIPTEXT)lp;
	lpTip->hinst = hInst;
	
	switch(lpTip->hdr.idFrom){ 
		
	case ID_TBOPEN:		  
		lpTip->lpszText = "t@CJ";
		break;	
		
	case ID_TBCLOSE:
		lpTip->lpszText = "t@C";
		break;		
		
	case ID_TBCOPY:
		lpTip->lpszText = "摜̃Rs[";
		break;		
		
	case ID_TBSAVE:
		lpTip->lpszText = "摜̕ۑ";
		break;		
		
	case ID_TBTOHEAD:
	case ID_TBREWIND:
	case ID_TBPLAY:	 
	case ID_TBPAUSE:
	case ID_TBFORWARD:
	case ID_TBTOTAIL:
		lpTip->lpszText = "";
		break;
		
	case ID_TBSEIMON: 
		lpTip->lpszText = "";
		break;
		
	case ID_TBSPEC:	
		lpTip->lpszText = "XyNg";
		break;	 
		
	case ID_TBHAKEI:	
		lpTip->lpszText = "g`";
		break;	 
		
	case ID_TBYAXIS:
		lpTip->lpszText = "Ԏ\";
		break;
		
	case ID_TBFRAMESIZE:
		lpTip->lpszText = "摜̊g";
		break;	  
		
	case ID_TBRESET:
		lpTip->lpszText = "Zbg";
		break;	  
		
	case ID_TBHELP:
		lpTip->lpszText = "wv";
		break;	 
		
	case ID_TBSETTING:
		lpTip->lpszText = "ڍאݒ";
		break;	 
		
	case ID_TBLOCKON:	
		lpTip->lpszText = "^";
		break;	 
	}		
}



//-------------------------------------
// XN[o[̈ʒuvZ SCROLLINFO ɃZbg֐
VOID MoveScrPos(LPSCROLLINFO lpSbInfo,WPARAM wp){
	
	switch (LOWORD(wp)) {
		
	case SB_LINEUP:   
		
		lpSbInfo->nPos -= 1;	
		break;
		
	case SB_LINEDOWN:	
		
		lpSbInfo->nPos += 1;	
		break;
		
	case SB_PAGEUP:   
		lpSbInfo->nPos -= lpSbInfo->nPage;	
		break;
		
	case SB_PAGEDOWN: 
		lpSbInfo->nPos += lpSbInfo->nPage;	
		break;
		
	case SB_THUMBTRACK:  
		lpSbInfo->nPos += (HIWORD(wp) - lpSbInfo->nPos);	
		break;
	}		
	
	if(lpSbInfo->nPos > lpSbInfo->nMax) lpSbInfo->nPos = lpSbInfo->nMax;  
	else if(lpSbInfo->nPos < lpSbInfo->nMin ) lpSbInfo->nPos = lpSbInfo->nMin;
	
}



//-------------------------------------
// f[^֐
VOID InitData(HWND hWnd,LPSCROLLINFO lpSbInfo 
			  , LPBYTE* lppBitBuf , LPBYTE* lppWaveData, 
			  double** lppdFftData,HBITMAP* lpHbDIB,LPHANDLE lpWaveHdFile){				
	
	SetWindowText(hWnd,(LPCSTR)""); //^Cg߂
	
	// ̊J
	
	// Wavẽf[^
	if(*lppWaveData != NULL) {	
		if(GlobalFree(*lppWaveData)!=NULL) 
			MessageBox(hWnd, "̊JɎs܂B", 
			"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
		else *lppWaveData = NULL;
				}
	
	// FFT ̃f[^
	if(*lppdFftData != NULL) {
		if(GlobalFree(*lppdFftData)!=NULL) 
			MessageBox(hWnd, "̊JɎs܂B", 
			"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
		else *lppdFftData = NULL;
				}
	
	// DIB ̍폜
	if(*lpHbDIB != NULL){
		if(DeleteObject(*lpHbDIB)!=TRUE) 
			MessageBox(hWnd, "DIB ̍폜Ɏs܂B",
			"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
		else *lpHbDIB = NULL;
	}

	// rbg}bvf[^̊J
	if(*lppBitBuf != NULL) {	
		if(GlobalFree(*lppBitBuf)!=NULL) 
			MessageBox(hWnd, "̊JɎs܂B", 
			"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
		else *lppBitBuf = NULL;
	}	
	
	
	// t@CN[Y
	if(*lpWaveHdFile != NULL){
		CloseHandle(*lpWaveHdFile);
		*lpWaveHdFile = NULL;
	}
	
	//j[Is
	HMENU hMenu;	  
	hMenu = GetMenu(hWnd);	 
	EnableMenuItem(hMenu,IDM_CLOSE,MF_GRAYED);	
	EnableMenuItem(hMenu,IDM_SAVE,MF_GRAYED);  
	EnableMenuItem(hMenu,IDM_COPY,MF_GRAYED);	 										
	EnableMenuItem(hMenu,IDM_TOHEAD,MF_GRAYED);	 										
	EnableMenuItem(hMenu,IDM_REWIND,MF_GRAYED);
	EnableMenuItem(hMenu,IDM_PLAY,MF_GRAYED);	 										
	EnableMenuItem(hMenu,IDM_PAUSE,MF_GRAYED);
	EnableMenuItem(hMenu,IDM_FORWARD,MF_GRAYED);
	EnableMenuItem(hMenu,IDM_TOTAIL,MF_GRAYED);	 										
	
	// c[o[Is   
	SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
		TB_ENABLEBUTTON,(WPARAM)ID_TBSAVE,(LPARAM)MAKELONG(FALSE, 0));	
	SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
		TB_ENABLEBUTTON,(WPARAM)ID_TBCOPY,(LPARAM)MAKELONG(FALSE, 0));	
	SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
		TB_ENABLEBUTTON,(WPARAM)ID_TBCLOSE,(LPARAM)MAKELONG(FALSE, 0));	
	SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
		TB_ENABLEBUTTON,(WPARAM)ID_TBTOHEAD,(LPARAM)MAKELONG(FALSE, 0));	
	SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
		TB_ENABLEBUTTON,(WPARAM)ID_TBREWIND,(LPARAM)MAKELONG(FALSE, 0));	
	SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
		TB_ENABLEBUTTON,(WPARAM)ID_TBPLAY,(LPARAM)MAKELONG(FALSE, 0));	
	SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
		TB_ENABLEBUTTON,(WPARAM)ID_TBPAUSE,(LPARAM)MAKELONG(FALSE, 0));	
	SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
		TB_ENABLEBUTTON,(WPARAM)ID_TBFORWARD,(LPARAM)MAKELONG(FALSE, 0));	
	SendMessage(GetDlgItem(hWnd,ID_TOOLBAR),
		TB_ENABLEBUTTON,(WPARAM)ID_TBTOTAIL,(LPARAM)MAKELONG(FALSE, 0));	
	
	// Xe[^Xo[ 
	SendMessage(GetDlgItem(hWnd,ID_STATBAR),SB_SETTEXT,0|0,(LPARAM)"Ready"); 
	SendMessage(GetDlgItem(hWnd,ID_STATBAR),SB_SETTEXT,1|0,(LPARAM)""); 
	SendMessage(GetDlgItem(hWnd,ID_STATBAR),SB_SETTEXT,2|0,(LPARAM)""); 
	
	// XN[o[
	lpSbInfo->cbSize = sizeof(SCROLLINFO);
	lpSbInfo->nMin = 0;
	lpSbInfo->nMax = 0;
	lpSbInfo->nPage = 0;
	lpSbInfo->nPos = 0;
	
	SendMessage(GetDlgItem(hWnd,ID_SCRBAR),TBM_SETRANGE
		,(WPARAM)TRUE,MAKELPARAM(lpSbInfo->nMin,lpSbInfo->nMax));
	SendMessage(GetDlgItem(hWnd,ID_SCRBAR),TBM_SETPAGESIZE,0,(LPARAM)(lpSbInfo->nPage));
	SendMessage(GetDlgItem(hWnd,ID_SCRBAR),TBM_SETTICFREQ	,(WPARAM)20,(LPARAM)0);
	SendMessage(GetDlgItem(hWnd,ID_SCRBAR),TBM_SETPOS,(WPARAM)TRUE,(LPARAM)(lpSbInfo->nPos)); 
}



//-------------------------------------------------------------------
// t@CI_CAO\֐
BOOL SelectMyFiles(HWND hWnd , WORD loadOrSave , char* filePathName, char* saveFileName)
		  {
	OPENFILENAME ofn; 
	char CurDir[CHR_BUF]; 
	char fPath[CHR_BUF],fDrive[CHR_BUF],fName[CHR_BUF],fExt[CHR_BUF];
	char fileName[MAX_PATH];
	
	// t@C
	_splitpath(filePathName,fDrive,fPath,fName,fExt);

	// JgtH_擾
	GetCurrentDirectory(CHR_BUF,CurDir); 
	
	// ݒ
	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.nMaxFile = MAX_PATH;
	ofn.nMaxFileTitle = CHR_BUF;
	ofn.lpstrFileTitle = NULL;
	ofn.lpstrInitialDir = CurDir;
	
	if(loadOrSave == 1){ // Z[u
		
		// Z[ut@CZbg
		wsprintf(fileName,"%s.bmp",fName);  
		
		ofn.lpstrFilter = "BMP t@C(*.bmp)\0*.bmp\0All Files(*.*)\0*.*\0\0";
		ofn.lpstrFile = fileName;
		ofn.Flags = OFN_OVERWRITEPROMPT|OFN_PATHMUSTEXIST|OFN_EXPLORER|OFN_HIDEREADONLY;
		ofn.lpstrDefExt = "bmp";
		ofn.lpstrTitle = "ۑ摜t@CI";
		
		if (GetSaveFileName(&ofn) == 0) return FALSE;
		
		wsprintf(saveFileName,"%s",fileName);
		
	}
	else{ //@[h
		
		// [ht@CZbg
		wsprintf(fileName,"%s%s",fName,fExt);  
		
		ofn.lpstrFilter = "WAVE t@C(*.wav)\0*.wav\0All Files(*.*)\0*.*\0\0";
		ofn.lpstrFile = fileName;
		ofn.Flags = OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|OFN_EXPLORER|OFN_HIDEREADONLY;
		ofn.lpstrDefExt = "wav";
		ofn.lpstrTitle = "t@CI";
		
		if (GetOpenFileName(&ofn) == 0) return FALSE;
		
		wsprintf(filePathName,"%s",fileName);
	}
	
	return TRUE; 
}


//-------------------------------------------------------------------
// XN[o[ZbgāAb\֐
VOID SetMyTimeBar(HWND hWnd,DWORD fftPoint,LPSCROLLINFO lpSbInfo ,WAVEFORMATEX waveFmt){
	
	CHAR str[CHR_BUF];	
	DWORD dwTime;
	
	SendMessage(GetDlgItem(hWnd,ID_SCRBAR),TBM_SETPOS,(WPARAM)TRUE,(LPARAM)(lpSbInfo->nPos)); 
	
	dwTime = (DWORD)((double)fftPoint/(double)waveFmt.nSamplesPerSec*(double)lpSbInfo->nPos*1000);
	wsprintf(str,"%4d.%03d s",dwTime/1000,dwTime-(dwTime/1000)*1000);
	SendMessage(GetDlgItem(hWnd,ID_STATBAR),SB_SETTEXT,2|0,(LPARAM)str);
	
	return;
}



//-------------------------------------------------------------------
// KvZ֐
// A=0 A#=1 B=2 C=3 C#=4 D=5 D#=6 E=7 F=8 F#=9 G=10 G#=11 A=12
void CalcMusicScale(WORD* lpOct,WORD* lpScale,double freq){
	
	double curOct,curScale,curFreq;
	
	// IN^[uvZ
	
	curOct = 0;
	curFreq = 13.75; // IN^[u 0  A ̎g
	curScale = 0;
	
	while(curFreq*2 < freq){
		curOct++;
		curFreq *=2;
	}
	
	double wait = exp(log(2)/12);
	
	while(freq > (wait/2+0.5)*curFreq){
		curFreq *= wait;
		curScale++;
		if(curScale==3)curOct++;
	}
	
	*lpOct = (WORD)curOct;
	*lpScale = (WORD)curScale;
}



//-------------------------------------------------------------------
// }EX{^_̉KvZ֐
VOID PointMusicScale(HWND hWnd,DWORD fftPoint,double* lpdFftData,
					 WAVEFORMATEX waveFmt ,DWORD waveDataSize,
					 LPBITMAPINFO  lpBitInfo ,
					 DWORD childWidth,DWORD childHeight,
					 int scrX,int scrY, int xPos, int yPos, DWORD pos ,
					 DWORD widthRate,DWORD heightRate,BOOL bLogX){
	
	DWORD pos2;	// rbg}bv̎ۂ̃Rs[
	
	// Gpϐ
	char str[CHR_BUF];
	
	//@WAVE ̏
	DWORD  dwFftHeight,dwBlockNo;
	SHORT waveChn,waveBit; 
	LONG  waveRate;
	
	waveChn = (SHORT)waveFmt.nChannels;	  //`l
	waveRate = (LONG)waveFmt.nSamplesPerSec; // [g
	waveBit = (SHORT)waveFmt.wBitsPerSample; // rbg
	dwBlockNo = waveDataSize/(fftPoint*waveChn*waveBit/8)+1; 	// vbN 
	dwFftHeight = fftPoint/2;	 // bitmap  (1 `l) 							   
	
	// t[̑傫AʒuvZ
	// scrX,scrY  z`̈(childWidth,childHeight)
	// (ۂ)NCAg̈(clientWidth,clientHeight) ɑ΂ʒu
	DWORD frameWidth = DEFAULT_FFTPOINT/2*widthRate;  // g@1 ̓̕
	DWORD frameHeight = DEFAULT_FFTPOINT/2*heightRate;  // g@1 ̓̍
	DWORD leftTopX = (childWidth-(frameWidth+2+(8+frameWidth+2)*(waveChn-1)))/2 +scrX ; // g̍@́@x  W
	DWORD leftTopY = (childHeight-(frameHeight+2))/2 +scrY; //  ́@y W
	
	// rbg}bṽRs[ x W̌vZ
	if(pos < fftPoint/2 /2){
		pos2 = 0;	 
	}	  
	else if(pos-fftPoint/2 /2 <= (lpBitInfo->bmiHeader.biWidth-60)-fftPoint/2){ 
		pos2 = pos-fftPoint/2/2;
	}
	else {
		pos2 = (lpBitInfo->bmiHeader.biWidth-60)-fftPoint/2;
	}
	
	// ۂ̍W̌vZ
	if(xPos>=0){ 
		int bitMapY,bitFreq,bitMapX,bitChn;
		double bitPower;
		char szBitPower[10];
		WORD wOct,wScale;
		char *musicScale[13]={"A","A#","B","C","C#","D","D#","E","F","F#","G","G#","A"};
		
		// rbg}bv x W̌vZ
		bitChn = 0;
		bitMapX = xPos - leftTopX  ; 
		
		// E`l̏ꍇ
		if(waveChn == 2 && bitMapX >= (int)frameWidth+8+2+1) {
			bitMapX -= (frameWidth+8+2+1);
			bitChn = 1;
		}
		bitMapX = (int)( (double)(bitMapX/widthRate)*((double)fftPoint/512) )+pos2;
		if(bitMapX <0 || bitMapX >(int)dwBlockNo-1
			|| bitMapX <(int)pos2 || bitMapX >(int)(pos2+fftPoint/2)) bitMapX = -1;
		
		// rbg}bv y W̌vZ
		bitMapY = (int)( ((double)(frameHeight-(yPos - leftTopY)))/(double)heightRate
			*((double)fftPoint/512) ); 
		if(bitMapY <0 || bitMapY >(int)dwFftHeight-1) bitMapY = -1;
		
		
		if(bitMapX <0 || bitMapY<0) wsprintf(str,"");
		else{
			if(bLogX)
				bitFreq = (int)(pow((double)waveRate/2,(double)bitMapY / fftPoint *2)); // gvZ(OXP[)
			else bitFreq = (int)((double)bitMapY /fftPoint* waveRate); // gvZ(jA)

			// p[XyNg̒l擾
			bitPower = 
				10 * log10(
				lpdFftData[dwBlockNo*dwFftHeight*bitChn 
				+dwBlockNo* (DWORD)((double)dwFftHeight * bitFreq /(waveRate/2.)) + bitMapX]
				);

			_gcvt(bitPower,5,szBitPower);

			// KvZ
			CalcMusicScale(&wOct,&wScale,bitFreq);

			wsprintf(str,"%5d Hz %s db O%d%s", bitFreq,szBitPower
				,wOct,musicScale[wScale]);
		}
		
		// Xe[^Xo[XV
		SendMessage(GetDlgItem(GetParent(GetParent(hWnd)),ID_STATBAR),SB_SETTEXT,1|0,(LPARAM)str);
	}
	
	return;
}


//EOF